program Pef_ir2
  use sep
  use helix
  use createhelixmod
  use bound
  use misinput
  use pef_ir
  use compress
  use print
 
  implicit none
  integer, dimension (:), allocatable :: n, n0, a, center, gap, lagsave
  integer                             :: dim, n123, i, niter, na, tt(1000), nd
  real,    dimension (:), pointer     :: dd, kk, dist
!  real, dimension (:), allocatable    :: dist
  type( filter)                       :: aa   
  character (len = 6)                 :: varname
integer, external                       :: getch

  call sep_init (SOURCE)
  dim = sep_dimension ()
  allocate (n (dim), n0 (dim), center (dim), a (dim), gap (dim))
  call from_history (n)
  call to_history ("n",n)

nd = getch("dist","d",tt)
allocate( dist(nd))
dist(1:nd)=tt(1:nd)
call from_param ("dist", dist)

  call from_par ("a", a)
  center = 1
  where (a (2:) > 1) center (:dim-1) = a(:dim-1)/2 + 1
  call from_par ("center", center, center)
  call from_par ("na", na, 0)
  if (na == 0) then
     gap = 0
     call from_par ("gap", gap, gap)
     aa = createhelix( n, center, gap, a) ! allocate PEF
     n0 = n
     write(0,*)"# of coeffs:", size(aa%flt), aa%flt
  else
     call allocatehelix (aa, na)
     call from_par ("lag", aa%lag)
     call from_par ("n", n0)
  end if

  allocate(lagsave(size(aa%lag)))
  lagsave = aa%lag
write(0,*) "aa%lag",aa%lag
  n123 = product (n)
  allocate (dd (n123), kk (n123)) 
  call sep_read (dd)
  if (exist_file ("maskin")) then
     call sep_read (kk, "maskin")
  else
     kk = 1.
  end if
  
  call boundn( n0, n, a, aa) 
  call find_mask( (kk /= 0.), aa)   ! missing data

  if (exist_file ("maskout")) then
     where (aa%mis) 
        kk = 0.
     elsewhere
        kk = 1.
     end where
     do i=1, dim
        call to_history (axisname(i),n(i),"maskout")
     end do
     call to_history ("esize",4,"maskout")
     call sep_write (kk, "maskout")
  end if

  call from_par( "niter", niter, size(aa%lag)*2 )

  call find_pef_ir ( dd, aa, dist, n(1), niter)         ! estimate aa
  write(0,*)"lags:", aa%lag
  aa%lag=lagsave
  call resize( aa)                       ! eliminate zeroes
  call printn( n, center, a, aa)         ! print filter

  write(0,*)"# of coeffs:", size(aa%flt), aa%flt
  write(0,*)"lags:", aa%lag

  call to_history ("n1", size ( aa%lag))
  do i=2, dim
     call to_history (axisname(i),1)
  end do
  call to_history ("lag", aa%lag)
!  do i=1, size (aa%lag)
!     if (i < 10) then
!        write (varname,"(a,i1)") "lag",i
!     else if (i < 100) then
!        write (varname,"(a,i2)") "lag",i
!     else
!        write (varname,"(a,i3)") "lag",i
!     end if
!     call to_history_int (varname, aa%lag (i))
!  end do
  call sep_write (aa%flt)
 
  call sep_close ()
  deallocate (dd, kk)
  deallocate (n, n0, center, a, gap)
  call deallocatehelix( aa)
  call exit (0)
end program Pef_ir2
