module hconest_ir2
! masked helix convolution, adjoint is the filter.
  use adj_mod
  use helix
  use bound_ir
  implicit none
  real ,private,  dimension (:), pointer  :: x,d 
  type( filter), private :: aa 
  integer                :: m1,m2,naa
  integer, dimension (:), allocatable :: olag
  real, dimension(:,:), allocatable   :: lagr
  contains
  subroutine hconest_ir2_init ( x_in,na_in,aa_in,d_in,n1_in )
    real ,   dimension (:), pointer :: x_in, d_in
    type( filter)    :: aa_in 
    integer            :: n1_in,na_in, ia, i2
    write(0,*) "hconest_ir_init 1"
    x => x_in 
    d => d_in
    naa = na_in
    aa = aa_in
    n1 = n1_in
    n2 = size(d)+1
    write(0,*) "hconest_ir_init 2",n1,n2
    allocate(olag(size(aa%lag)),lagr(n2,size(aa%lag)))
    olag = aa%lag
    do i2=1,n2
       do ia=1,size(olag)
          lagr(i2,ia)=olag(ia)*d(i2)
          if (olag(ia)>n1/2) then
             lagr(i2,ia) = lagr(i2,ia)-n1*(d(i2)-1)
          end if
       end do
    end do
    call boundn_ir((/n1,n2/),(/n1,n2/),(/naa,2/),aa,d)
    write(0,*) "hconest_ir_init 3 aa%mis",aa%mis
  end subroutine
  function hconest_ir2_lop ( adj, add, a, y) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: a,y 
    call adjnull (adj,add,a,y )
    call hconest_ir2_lop2(adj,a,y )
    stat=0
  end function 
  subroutine hconest_ir2_lop2(adj,a,y)
    logical,intent(in) :: adj 
    real, dimension (:)  :: a 
    real, dimension (:)  :: y 
    integer  ia, ix, ixx, iy, o
o=0
!write(0,*)"a:", size(a)
!write(0,*)"y:", size(y)
!write(0,*)"x:", size(x)
!write(0,*)"d:", size(d)

do ix = 1,size(d)
!write(0,*)"lower bound 1:",(ix-1)*n1
!write(0,*)"upper bound 1:",(ix)*n1-1
!write(0,*)"upper bound 2:",(ix+1)*n1-1
   do ia = 1, size(a)
      aa%lag(ia) = int(lagr(ix,ia))
      fr = lagr(ix,ia)-aa%lag(ia)
      do iy = 1  + ((ix-1)*n1) + aa%lag( ia), (ix+1)*n1
         if (aa%mis( iy)) cycle
         o=o+1
         ixx = iy - aa%lag( ia)
         if ( adj) then
            a( ia) =    a( ia) +  y( iy) * (fr*x( ixx)+(1-fr)*x( ixx+1))
         else
            y( iy) =    y( iy) +  a( ia) * (fr*x( ixx)+(1-fr)*x( ixx+1))
         end if
      end do
   end do
!   write(0,*) "hconest_ir_lop, ix, lags",ix,d(ix), aa%lag 
end do
!                   write(0,*) "hconest_ir_lop, adj",adj
write(0,*)"number of operations", o
!write(0,*)"# of coeffs:", size(aa%flt), aa%flt
  end subroutine 
  subroutine hconest_ir2_close()
    aa%lag=olag
  end subroutine 
end module 
