module hconest_ir_old
! masked helix convolution, adjoint is the filter.
  use adj_mod
  use helix
  implicit none
  real ,private,  dimension (:), pointer  :: x,d 
  type( filter), private :: aa 
  integer                :: n1,n2
  integer, dimension (:), allocatable :: oldlag
  real                   :: lagreal,jump
  contains
  subroutine hconest_ir_init ( x_in,aa_in,d_in,n1_in )
    real ,   dimension (:), pointer :: x_in, d_in
    type( filter)    :: aa_in 
    integer            :: n1_in
    write(0,*) "hconest_ir_init 1"
    x => x_in 
    d => d_in
    aa = aa_in
    n1 = n1_in
    n2 = size(x)/n1
    write(0,*) "hconest_ir_init 2"
    allocate(oldlag(size(aa%lag)))
    oldlag = aa%lag
    write(0,*) "hconest_ir_init 3"
  end subroutine
  function hconest_ir_lop ( adj, add, a, y) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: a,y 
    call adjnull (adj,add,a,y )
    call hconest_ir_lop2(adj,a,y )
    stat=0
  end function 
  subroutine hconest_ir_lop2(adj,a,y)
    logical,intent(in) :: adj 
    real, dimension (:)  :: a 
    real, dimension (:)  :: y 
    integer  ia, ix, ixx, iy, switch

!write(0,*)"a:", size(a)
do ix = 1,size(d)
!write(0,*)"lower bound 1:",(ix-1)*n1
!write(0,*)"upper bound 1:",(ix)*n1-1
!write(0,*)"upper bound 2:",(ix+1)*n1-1
   do ia = 1, size(a)
      if (oldlag(ia)<n1 .and. oldlag(ia)>n1/2) then
         jump=(n1-oldlag(ia))*(d(ix)-1)
         lagreal = oldlag(ia) - jump
      else
         jump=(mod(oldlag(ia),n1)-1)*(d(ix)-1)
         lagreal = oldlag(ia) + jump
      end if
      aa%lag(ia) = int(lagreal)
      lagreal = lagreal-int(lagreal)
      if (lagreal>1) write(0,*)"OH SHIT!",lagreal
      switch=0
      if (aa%lag(ia)<(n1/2)) then
         do iy = 1  + ((ix-1)*n1) + aa%lag( ia), (ix)*n1-1
            if ( aa%mis( iy) .or. aa%mis( iy+1)) cycle  
            ixx = iy - aa%lag( ia)
            if ( adj) then
               a( ia) =    a( ia) +  y( iy) * ((lagreal)*x( ixx)+(1-lagreal)*x( ixx+1))
            else
               y( iy) =    y( iy) +  a( ia) * ((lagreal)*x( ixx)+(1-lagreal)*x( ixx+1))
            end if
         end do
      else
         do iy = 1  + ((ix-1)*n1) + aa%lag( ia), (ix+1)*n1-1
            if ( aa%mis( iy) .or. aa%mis( iy+1)) cycle  
            ixx = iy - aa%lag( ia)
            if ( adj) then
               a( ia) =    a( ia) +  y( iy) * ((lagreal)*x( ixx)+(1-lagreal)*x( ixx+1))
            else
               y( iy) =    y( iy) +  a( ia) * ((lagreal)*x( ixx)+(1-lagreal)*x( ixx+1))
            end if
         end do
      end if
!                   write(0,*) "lagreal",lagreal
   end do
                   write(0,*) "hconest_ir_lop, ix, lags",ix,d(ix), aa%lag 
end do
!                   write(0,*) "hconest_ir_lop, adj",adj
!write(0,*)"lag a:", aa%lag
!     write(0,*)"# of coeffs:", size(aa%flt), aa%flt
  end subroutine 
  subroutine hconest_ir_close()
  end subroutine 
end module 
