module lintn 
! Linear interpolation in n-D
  use adj_mod
  use helixcartmod
  implicit none
  integer, pointer               :: n(:), iloc(:,:) 
  integer, pointer, dimension(:) :: ipos, my2, imod
  real, pointer                  :: o(:), d(:), f(:,:), g(:,:), xy(:,:)
  logical, pointer               :: breaker(:)
  integer                        :: nd, ndim
  contains
  subroutine lintn_init ( n_in,o_in,d_in,xy_in )
    integer, dimension (:), target    :: n_in 
    real,    dimension (:), target    :: o_in 
    real,    dimension (:), target    :: d_in 
    real ,   dimension (:,:), pointer :: xy_in 
    integer                           :: idata, idim
!                                                                                      write(0,*)'lintn_init0'
!                                                                                      write(0,*)size(xy_in,1)
    n => n_in 
    o => o_in 
    d => d_in 
    xy => xy_in
  !                                                                                    write(0,*)'lintn_init1', size(xy,2)
    nd = size(xy_in,1)
    ndim = size(n_in)
!
  !                                                                                    write(0,*)'lintn_init2',nd,ndim
    allocate(ipos(ndim), my2(ndim), imod(ndim))

 !                                                                                     write(0,*)'lintn_init3',ndim,nd,size(xy,1)
    my2 = 2
    allocate(f(ndim,nd), g(ndim,nd), iloc(ndim,nd), breaker(nd))
 !                                                                                     write(0,*)'lintn_init4', size(xy,1),size(xy,2)
    do idata=1,nd
!                                                                                      write(0,*)'lintn_init5',idata
       do idim=1,ndim
!                                                                                      write(0,*)'lintn_init6',idim,xy(idata,idim)
          f(idim,idata) = (xy(idata,idim)-o(idim))/d(idim)
!                                                                                      write(0,*)'lintn_init7'
          if (f(idim,idata) < 1) then
             breaker(idata)=.true.
!             f(idim,idata) = 1.
             end if
!                                                                                      write(0,*)'lintn_init8'
          if (f(idim,idata) > n(idim)-1) then
!             f(idim,idata) = n(idim) - .001
             breaker(idata)=.true.
             end if
          end do
       end do
   !                                                                                   write(0,*)'lintn_init9'
    iloc = f; f = f-iloc; g = 1-f
  end subroutine
  function lintn_lop ( adj, add, mm, dd) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: mm,dd 
    call adjnull (adj,add,mm,dd )
    call lintn_lop2(adj,mm,dd )
    stat=0
  end function 
  subroutine lintn_lop2(adj,mm,dd)
    logical,intent(in) :: adj  
    real, dimension (:)  :: mm, dd 
    integer :: id, im, idata, imod_pts, idim
    real    :: fract
  !                                                                      write(0,*)'lintn_lop1 nd', nd,'f', size(f),'iloc', size(iloc), ndim
    do id= 1,nd
       if (breaker(id)) cycle
 !                                                                                     write(0,*)'lintn_lop2'
       do imod_pts=1,2**ndim
 !                                                                                     write(0,*)'lintn_lop3'
          fract = 1
          call helix2cart(my2, imod_pts, imod)
 !                                                                                     write(0,*)'lintn_lop4',imod
          ipos = iloc(:,id) + imod - 1
 !                                                                                     write(0,*)'lintn_lop4.1',ipos
          call cart2helix(n,ipos,im)
 !                                                                                     write(0,*)'lintn_lop5', id,imod_pts,im
          do idim=1,ndim
 !                                                                                     write(0,*)'lintn_lop6',imod(idim)
             fract = fract * ((0.5*(1 - (-1)**imod(idim))) + f(idim,id)*((-1)**imod(idim)))
          end do
          if (fract<0) write(0,*)"SHIT!!!!!"   
          if (.not. adj) then
 !                                                                                     write(0,*)'lintn_lop7'
             dd(id) = dd(id) + mm(im)*fract
          else
 !                                                                                     write(0,*)'lintn_lop7 fract', fract
             mm(im) = mm(im) + dd(id)*fract
             end if
          end do
       end do
 !                                                                                     write(0,*)'lintn_lop8 mm', mm
  end subroutine 
  subroutine lintn_close()
  end subroutine 
end module 
