module mis2x
  use mask1 
  use  helicon 
  use  polydiv 
  use  cgstep_mod 
  use  solver_mod
implicit none
  contains
! fill in missing data by minimizing power out of a given filter.
! by helix magic works in any number of dimensions
  subroutine mis1( niter, xx, aa, known, doprec, wght )
    logical,                intent( in)     :: doprec
    integer,                intent( in)     :: niter
    type( filter),          intent( in)     :: aa
    logical, dimension( :), intent( in)     :: known
    real,    dimension( :), intent( in)     :: wght
    real,    dimension( :), intent( in out) :: xx	! fitting variables
    real,    dimension( :), allocatable     :: dd
    logical, dimension( :), pointer         :: kk
    integer                                 :: nx
    nx = size( xx)
    if ( doprec) then
!  preconditioned
write(0,*) 'mis2x - a'
      allocate( kk( nx))
      kk = known
      call mask1_init( kk)
      call polydiv_init( nx, aa)
write(0,*) 'mis2x - b'
      call solver_prec( mask1_lop, cgstep, niter= niter, x= xx, dat= xx&
        &,prec= polydiv_lop, nprec= nx, eps= 0., wt=wght)
write(0,*) 'mis2x - c'
      call polydiv_close()
      deallocate( kk)
    else
!  regularized
      allocate( dd( nx))
      dd = 0.
      call helicon_init( aa)
      call solver( helicon_lop, cgstep, niter= niter, x= xx, dat= dd&
        &,known = known, x0= xx, wt=wght)
      deallocate( dd)
    end if 
    call cgstep_close( )
  end subroutine 
end module 
