module pef_ir
! Find prediction-error filter (helix magic)
  use hconest_ir
  use helicon_ir
  use cgstep_mod
  use solver_mod
  use dottest
  implicit none
  contains
  subroutine find_pef_ir( dd, aa, d, n1, niter)
    integer,          intent( in)  :: niter, n1        
    ! number of iterations
    type( filter)                  :: aa           ! filter
    real,    dimension(:), pointer :: dd, d           ! input data

    real, dimension (2)            :: dot1, dot2

    call hconest_ir_init( dd, aa, d, n1)
    write(0,*) "pef_ir before solver"
    write(0,*)" pef_ir # of coeffs:", size(aa%flt), aa%flt
!    call dot_test(hconest_ir_lop,size(aa%flt),size(dd),dot1,dot2)
    call solver( hconest_ir_lop, cgstep, aa%flt, -dd, niter, x0= aa%flt, verb=.true.)
!    write(0,*) "pef_ir after solver"
    call cgstep_close()
  end subroutine 
end module 
