module tcaf_ir
! Transient Convolution, Adjoint is the Filter, 1-D
  use adj_mod
  implicit none
  real ,private,  dimension (:,:), pointer  :: xx 
  real ,private,  dimension (:),   pointer  :: dd
  real, private                             :: ar
  contains
  subroutine tcaf_ir_init ( xx_in, dd_in, ar_in )
    real ,   dimension (:,:), pointer :: xx_in 
    real ,   dimension (:),   pointer :: dd_in 
    real                              :: ar_in
    xx => xx_in
    dd => dd_in
    ar = ar_in
  end subroutine
  function tcaf_ir_lop ( adj, add, bb, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: bb,yy 
    call adjnull (adj,add,bb,yy )
    call tcaf_ir_lop2(adj,bb,yy )
    stat=0
  end function 
  subroutine tcaf_ir_lop2(adj,bb,yy)
    logical,intent(in) :: adj 
    real, dimension (:)  :: bb 
    real, dimension (:)  :: yy 
    integer        x,   b,   y
    if ( size(yy) < size(xx) + size(bb) - 1 ) then
      call erexit('tcaf')
    end if
    do b= 1, size(bb)
      do x= 1, size(xx)
        y = x + b - 1
        if ( adj) then
          bb(b) =        bb(b) +  yy(y) * xx(x)
        else
          yy(y) = 	        yy(y) +  bb(b) * xx(x)
        end if
      end do
    end do
  end subroutine 
  subroutine tcaf_ir_close()
  end subroutine 
end module 
